ProyectoLenguajes/Areas/Admin/Controllers/DishController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using ProyectoLenguajes.Data.Repository.IRepository;
using ProyectoLenguajes.Models;
using ProyectoLenguajes.Utility;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace ProyectoLenguajes.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = RoleName.Role_Admin)]
    public class DishController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;
        private readonly IWebHostEnvironment _hostEnvioronment;

        public DishController(IUnitOfWork unitOfWork, IWebHostEnvironment hostEnvironment)
        {
            _unitOfWork = unitOfWork;
            _hostEnvioronment = hostEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public IActionResult Upsert(int? id)
        {
            Dish dish = new Dish();
            if (id == null) //create
            {
                return View(dish);
            }
            dish = _unitOfWork.Dish.Get(id.GetValueOrDefault());

            if (dish == null)
            {
                return NotFound();
            }
            return View(dish);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Upsert(Dish dish)
        {
            if (ModelState.IsValid)
            {
                string webRootPath = _hostEnvioronment.WebRootPath;
                var files = HttpContext.Request.Form.Files; //obtener direccion de archivos

                if (files.Count > 0)
                {
                    //si se agregó una imagen, hay que eliminar la direccion anterior del producto
                    Dish dishDB = _unitOfWork.Dish.Get(dish.Id);
                    if (dishDB != null)
                    {
                        var imagePath = Path.Combine(webRootPath, dishDB.PhotoUrl.TrimStart('\\'));

                        if (System.IO.File.Exists(imagePath))
                        {
                            System.IO.File.Delete(imagePath);//eliminar archivo existente
                        }
                    }

                    string fileName = Guid.NewGuid().ToString();
                    var uploads = Path.Combine(webRootPath, @"images\dishes");
                    var extension = Path.GetExtension(files[0].FileName);

                    dish.PhotoUrl = @"\images\dishes\" + fileName + extension;

                    using (var fileStreams = new FileStream(Path.Combine(uploads, fileName + extension),
                                FileMode.Create))
                    {

                        files[0].CopyTo(fileStreams);
                    } //para escribir un archivo
                }
                else //no changes in image
                {
                    if (dish.Id != 0)//verificar que es un update
                    {
                        Dish dishDB = _unitOfWork.Dish.Get(dish.Id);
                        dish.PhotoUrl = dishDB.PhotoUrl;
                    }
                }

                if (dish.Id == 0) //insert
                {
                    _unitOfWork.Dish.Add(dish);
                }
                else
                {
                    _unitOfWork.Dish.Update(dish);
                }
                _unitOfWork.Save();
                return RedirectToAction(nameof(Index));
            }

            return View(dish);
        }

        #region API CALLS

        [HttpGet]
        public IActionResult GetAll()
        {
            var allObjetcs = _unitOfWork.Dish.GetAll();
            return Json(new { data = allObjetcs });
        }

        [HttpDelete]
        public IActionResult Delete(int id)
        {
            var dish = _unitOfWork.Dish.Get(id);

            if (dish == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            string webRootPath = _hostEnvioronment.WebRootPath;
            var imagePath = Path.Combine(webRootPath, dish.PhotoUrl.TrimStart('\\'));

            if (System.IO.File.Exists(imagePath))
            {
                System.IO.File.Delete(imagePath);//eliminar archivo existente
            }

            _unitOfWork.Dish.Remove(dish);
            _unitOfWork.Save();
            return Json(new { success = true, message = "Deleted successfully" });
        }

        #endregion
    }
}

ProyectoLenguajes/Areas/Admin/Controllers/OrderController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.IO;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using ProyectoLenguajes.Data.Repository.IRepository;
using ProyectoLenguajes.Models;
using Microsoft.AspNetCore.Authorization;
using ProyectoLenguajes.Utility;
using System.Threading;

namespace ProyectoLenguajes.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = RoleName.Role_Admin)]
    public class OrderController:Controller
    {
        private readonly IUnitOfWork _unitOfWork;
        private readonly IWebHostEnvironment _hostEnvioronment;

        public OrderController(IUnitOfWork unitOfWork, IWebHostEnvironment hostEnvironment)
        {
            _unitOfWork = unitOfWork;
            _hostEnvioronment = hostEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public IActionResult EditOrder(int? id)
        {
            Order order = new Order();
            if (id == null) 
            {
                return View(order);
            }
            order = _unitOfWork.Order.Get(id.GetValueOrDefault());
            order.ApplicationUser = _unitOfWork.ApplicationUser.GetAll().Where(I => I.Id == order.ApplicationUserId).FirstOrDefault();

            if (order == null)
            {
                return NotFound();
            }
            return View(order);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult EditOrder(Order order)
        {
            _unitOfWork.Order.Update(order);
            _unitOfWork.Save();
            return RedirectToAction(nameof(Index));
        }

        #region API CALLS

        [HttpGet]
        public IActionResult GetAll()
        {
            var allObjetcs = _unitOfWork.Order.GetAll();
            foreach (var item in allObjetcs)
            {
                item.ApplicationUser = _unitOfWork.ApplicationUser.GetAll().Where(I=>I.Id == item.ApplicationUserId).FirstOrDefault();
            }
            return Json(new { data = allObjetcs });
        }

        [HttpDelete]
        public IActionResult Delete(int id)
        {
            var order = _unitOfWork.Order.Get(id);

            if (order == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }
            _unitOfWork.Order.Remove(order);
            _unitOfWork.Save();
            return Json(new { success = true, message = "Deleted successfully" });
        }
        #endregion
    }
}

ProyectoLenguajes/Areas/Admin/Controllers/UserController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using ProyectoLenguajes.Data;
using ProyectoLenguajes.Data.Repository.IRepository;
using ProyectoLenguajes.Models;
using ProyectoLenguajes.Utility;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace ProyectoLenguajes.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Authorize(Roles = RoleName.Role_Admin)]
    public class UserController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;
        private readonly IWebHostEnvironment _hostEnvioronment;

        public UserController(IUnitOfWork unitOfWork, IWebHostEnvironment hostEnvironment)
        {
            _unitOfWork = unitOfWork;
            _hostEnvioronment = hostEnvironment;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public IActionResult Upsert(string? id)
        {

            ApplicationUser user = new ApplicationUser();
            if (id == null) //create
            {
                return View(user);
            }
            user = _unitOfWork.ApplicationUser.Get(id);

            if (user == null)
            {
                return NotFound();
            }
            return View(user);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Upsert(ApplicationUser user)
        {
            if (ModelState.IsValid)
            {
                if (user.Id == "")
                { //insert
                    _unitOfWork.ApplicationUser.Add(user);
                }
                else
                {//edit
                    _unitOfWork.ApplicationUser.Update(user);
                }
                _unitOfWork.Save();
                //redirecciona a index
                return RedirectToAction(nameof(Index));
            }
            //retorna vista actual con el objeto actual 
            return View(user);
        }

        #region API CALLS

        [HttpGet]
        public IActionResult GetAll()
        {
            List<ApplicationUser> users = new List<ApplicationUser>();
            var allObjetcs = _unitOfWork.ApplicationUser.GetAll();

            foreach (var item in allObjetcs)
            {
                if ((item.Role == "Admin") || (item.Role == "Cook"))
                    users.Add(item);
            }
            return Json(new { data = users });

        }
    
 
    


[HttpDelete]
        public IActionResult Delete(string id)
        {
            var user = _unitOfWork.ApplicationUser.Get(id);

            if (user == null)
            {
                return Json(new { success = false, message = "Error while deleting" });
            }

            _unitOfWork.ApplicationUser.Remove(user);
            _unitOfWork.Save();
            return Json(new { success = true, message = "Deleted Successfully" });
        }

        #endregion
    }
}

ProyectoLenguajes/Areas/Cook/Controllers/OrdersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using ProyectoLenguajes.Data;
using ProyectoLenguajes.Data.Repository.IRepository;
using ProyectoLenguajes.Models;
using ProyectoLenguajes.Models.ViewModels;
using ProyectoLenguajes.Utility;

namespace ProyectoLenguajes.Areas.Cook.Controllers
{
    [Area("Cook")]
    public class OrdersController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;

        public OrdersController(IUnitOfWork unitOfWork)
        {
            _unitOfWork = unitOfWork;
        }

        // GET: Cook/Orders
        public IActionResult Index()
        {
            return View();
        }

        [HttpGet]
        public IActionResult GetOrders()
        {

            IEnumerable<Order> orderList = _unitOfWork.Order.GetAll(
                includeProperties: "ApplicationUser",
                filter: (o => !o.Status.Equals(StatusName.Status_Delivered) && !o.Status.Equals(StatusName.Status_Annulled)));
            
            List<OrderViewModel> orderViews = new List<OrderViewModel>();

            foreach (var order in orderList)
            {
                OrderViewModel orderV = new OrderViewModel();
                orderV.custumer = order.ApplicationUser.Name;
                orderV.Status = order.Status;
                orderV.Id = order.Id;

                orderV.dishes = _unitOfWork.DishDetailsOrder.GetAll(filter: o => o.OrderId == order.Id);
                orderViews.Add(orderV);
            }
            return Json(new { data = orderViews });
        }

        // POST: Cook/Orders/Edit/
        [HttpPost]
        public async Task<IActionResult> CompleteOrder(int id)
        {
            await _unitOfWork.Order.Update(id, null);
            return Json(new { data = "Order completed" });
        }

        [HttpPost]
        public async Task<IActionResult> undoOrderCompleted(int id, string oldStatus) {
            await _unitOfWork.Order.Update(id, oldStatus);
            return Json(new { data = "The last completed plate has been returned" });
        }

    }
}

ProyectoLenguajes/Views/Shared/_CreateBackButtons.cshtml
<div class="row">
    <div class="col">
        <button type="submit" class="btn btn-primary form-control">Create</button>
    </div>
    <div class="col">
        <a asp-action="Index" class="btn btn-success form-control">Back to List</a>
    </div>
</div>

ProyectoLenguajes/Views/Shared/_EditBackButtons.cshtml
<div class="row">
    <div class="col">
        <button type="submit" class="btn btn-primary form-control" asp-route-id="@Model">Edit</button>
    </div>
    <div class="col">
        <a asp-action="Index" class="btn btn-success form-control">Back to List</a>
    </div>
</div>

ProyectoLenguajes/Views/Shared/_Layout.cshtml
@using ProyectoLenguajes.Utility

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ProyectoLenguajes</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />

    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.16/css/jquery.dataTables.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.min.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">ProyectoLenguajes</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        @if (User.IsInRole(RoleName.Role_Admin))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Dish" asp-action="Index">Dishes</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Order" asp-action="Index">Orders</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="User" asp-action="Index">Users</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="Admin" asp-controller="Customer" asp-action="Index">Customers</a>
                            </li>

                        }
                        @if (User.IsInRole(RoleName.Role_Cook))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="Cook" asp-controller="Orders" asp-action="Index">Cook</a>
                            </li>
                        }
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - ProyectoLenguajes - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
    <script src="https://kit.fontawesome.com/7a9ee38061.js" crossorigin="anonymous"></script>

    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>